<h1>Mot de passe oublié</h1>

<form class="container" id="dynamicForm" action="/motdepasseoublie" method="POST">
    <div id="dynamicSection">
        <div class="form-group">
            <label for="mail">Adresse email</label>
            <input type="email" required maxlength="100" autofocus class="form-control" id="mail" name="mail">
        </div>
    </div>
    <div id="alertSection">
        <!--ALERT-->
    </div>
    <div class="container text-center">
        <button class="btn btn-primary" type="submit">Valider</button>
    </div>
</form>
<script type="text/javascript">

    // Passage de l'étape 1 à l'étape 2
    function checkQuestion(event) {

        event.preventDefault()
        // On vérifie la réponse secrète avec AJAX
        $.ajax({url: "/api/lostPassword.php",
            data: {
                type: 'checkReponseSecrete',
                mail: document.getElementById("mail").value,
                reponse: document.getElementById("reponse").value
            },
            type: "POST",
            success: function (result,status) {

                // Si la réponse secrète est correcte
                if (status === 'success' && result != null && result === "OK") {

                    let dynamicSection = document.getElementById('dynamicSection')

                    document.getElementById('dynamicForm').removeEventListener('submit', checkQuestion)

                    // Animations de fondu en sortie
                    if(document.getElementById("alertSection").firstChild.classList !== undefined) { // Si il faut retirer l'alerte
                        document.getElementById("alertSection").firstChild.classList.remove('animate__zoomIn')
                        document.getElementById("alertSection").firstChild.classList.add('animate__animated', 'animate__fadeOut', 'animate__faster')
                    }
                    dynamicSection.classList.add('animate__animated', 'animate__fadeOut', 'animate__faster')

                    // Quand l'animation est terminée
                    dynamicSection.addEventListener('animationend', () => {
                        // On remplace le formulaire
                        document.getElementById('alertSection').innerHTML = "";
                        dynamicSection.innerHTML = "<h5>"+ document.getElementById('titre').innerText +"</h5>\n" +
                            "        <input type=\"email\" required maxlength=\"100\" style=\"width: 1px; height: 1px; visibility: hidden\" id=\"mail\" name=\"mail\" value=\""+ document.getElementById("mail").value+"\">" +
                            "<input type=\"string\" required maxlength=\"200\" style=\"width: 1px; height: 1px; visibility: hidden\" id=\"reponse\" name=\"reponse\" value=\""+ document.getElementById("reponse").value+"\">\n" +
                            "        <div class=\"form-group\">\n" +
                            "            <label for=\"password\">Entrez votre nouveau mot de passe</label>\n" +
                            "            <input type=\"password\" required class=\"form-control\" id=\"password\" name=\"password\">\n" +
                            "        </div>";

                        // On anime l'entrée de la nouvelle version.
                        dynamicSection.classList.remove('animate__fadeOut')
                        dynamicSection.classList.add('animate__fadeIn')
                        dynamicSection.addEventListener('animationend', () => {
                            document.getElementById('password').focus()
                            dynamicSection.classList.remove('animate__animated', 'animate__fadeIn', 'animate__faster')
                        }, {once: true})
                    }, {once: true})
                } else { // Pb de réponse secrète

                    let input = document.getElementById('reponse')
                    // Animation
                    input.classList.add('animate__animated', 'animate__shakeX', 'animate__faster', 'is-invalid')
                    input.addEventListener('animationend', () => input.classList.remove('animate__animated', 'animate__shakeX', 'animate__faster'), {once: true})
                    // Ajout du message d'alerte
                    document.getElementById("alertSection").innerHTML = "<div class=\"alert alert-danger animate__animated animate__zoomIn animate__faster\" role=\"alert\">Réponse incorrecte</div>";
                }
            }})
    }

    // Passage de l'étape 0 à l'étape 1
    function checkMail(event) {

        event.preventDefault()
        // On vérifie le mail avec AJAX
        $.ajax({url: "/api/lostPassword.php",
            data: {
                type: 'getQuestionSecrete',
                mail: document.getElementById("mail").value
            },
            type: "POST",
            success: function (result,status) {

                // Si le mail est bon
                if (status === 'success' && result != null && result.length === 2) {

                    let dynamicSection = document.getElementById('dynamicSection')

                    document.getElementById('dynamicForm').removeEventListener('submit', checkMail)

                    // Animations de fondu en sortie
                    if(document.getElementById("alertSection").firstChild.classList !== undefined) { // Si il faut retirer l'alerte
                        document.getElementById("alertSection").firstChild.classList.remove('animate__zoomIn')
                        document.getElementById("alertSection").firstChild.classList.add('animate__animated', 'animate__fadeOut', 'animate__faster')
                    }
                    dynamicSection.classList.add('animate__animated', 'animate__fadeOut', 'animate__faster')

                    // Quand l'animation est terminée
                    dynamicSection.addEventListener('animationend', () => {
                        // On remplace le formulaire
                        document.getElementById('alertSection').innerHTML = "";
                        dynamicSection.innerHTML = "<h5 id='titre'>Bonjour "+ result[0] +"</h5>\n" +
                            "        <input type=\"email\" required maxlength=\"100\" style=\"width: 1px; height: 1px; visibility: hidden\" id=\"mail\" name=\"mail\" value=\""+ document.getElementById("mail").value+"\">\n" +
                            "        <div class=\"form-group\">\n" +
                            "            <label for=\"reponse\">"+ result[1]+"</label>\n" +
                            "            <input type=\"string\" maxlength=\"200\" class=\"form-control\" id=\"reponse\" name=\"reponse\">\n" +
                            "        </div>";
                        document.getElementById('dynamicForm').addEventListener('submit', checkQuestion)
                        // On anime l'entrée de la nouvelle version.
                        dynamicSection.classList.remove('animate__fadeOut')
                        dynamicSection.classList.add('animate__fadeIn')
                        dynamicSection.addEventListener('animationend', () => {
                            document.getElementById("reponse").focus()
                            dynamicSection.classList.remove('animate__animated', 'animate__fadeIn', 'animate__faster')
                        }, {once: true})
                    }, {once: true})

                } else { // Pb de mail
                    let input = document.getElementById('mail')
                    // Animation
                    input.classList.add('animate__animated', 'animate__shakeX', 'animate__faster', 'is-invalid')
                    input.addEventListener('animationend', () => input.classList.remove('animate__animated', 'animate__shakeX', 'animate__faster'), {once: true})
                    // Ajout du message d'alerte
                    document.getElementById("alertSection").innerHTML = "<div class=\"alert alert-danger animate__animated animate__zoomIn animate__faster\" role=\"alert\">Compte introuvable</div>";
                }
            }})
    }
    document.getElementById("dynamicForm").addEventListener('submit', checkMail)
</script>
